
from copy import deepcopy

class Albero:
    def __init__(self, V, figli=[]):
        self.valore = V
        self.figli = figli

    def toList(self):
        return [self.valore, [f.toList() for f in self.figli] ]

    @classmethod
    def fromList(cls, lista):
        valore, figli = lista
        return cls(valore, [cls.fromList(f) for f in figli])

    def __eq__(self, other):
        return other != None and type(self) == type(other) and self.valore == other.valore and self.figli == other.figli

    def __repr__(self, livello=0):
        res = "{0}Nodo_{1}: {2.valore}".format("|  "*livello, id(self), self)
        for f in self.figli:
            res += "\n" + f.__repr__(livello+1)
        return res

if __name__ == '__main__':
    lista = [1, [
            [2, []],
            [3, [
                [4, []],
                [5, []]
                ]
            ],
            [6, []]
            ]
        ]
    albero = Albero.fromList(lista)
    albero2 = deepcopy(albero)

    print('A =', albero)
    print('B =', albero2)

    print('A is B', albero is albero2 )
    print('A == B', albero == albero2 )

    print('A ->', lista)
    print('B ->', albero.toList())

