#! /usr/bin/env python3 -B

from testlib import check, runtests
from json import load

from program02 import *

def contaGR(nodo):
    tot = 1
    for figlio in nodo.figli:
        tot += contaGR(figlio)
    return tot

def crea0GR(v1, v2, v3, v4, v5, v6, v7):
    return NodoA.fromList(
        [v1, [
            [v2, []],
            [v3, [
                [v4, []],
                [v5, [
                    [v6, []],
                    [v7, []]
                ]]
            ]]
        ]]
    )

def crea0GRSP(v1, v2, v3, v4, v5, v6, v7):
    return NodoA.fromList(
        [v1, [
            [v3, [
                [v5, [
                    [v7, []],
                    [v6, []],
                ]],
                [v4, []],
            ]],
            [v2, []],
        ]]
    )

def creaGR(v1, v2, v3, v4, v5, v6, v7, v8, v9, v10):
    return NodoA.fromList(
        [v1, [
            [v2, [
                [v4, []],
                [v5, []],
                [v6, [
                    [v8, []]
                ]],
            ]],
            [v3, [
                [v7, [
                    [v9, []],
                    [v10, []],
                ]],
            ]],
        ]]
    )

def crea1GR(v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15):
    return NodoA.fromList(
        [v1, [
            [v2, [
                [v4, [
                    [v11, []]
                ]],
                [v5, [
                    [v12, []]
                ]],
                [v6, [
                    [v8, [
                        [v13, []]
                    ]]
                ]],
            ]],
            [v3, [
                [v7, [
                    [v9, [
                        [v14, []]
                    ]],
                    [v10, [
                        [v15, []]
                    ]],
                ]],
            ]],
        ]]
    )

def crea2GR(v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20):
    return NodoA.fromList(
        [v1, [
            [v2, [
                [v4, [
                    [v11, [
                        [v16, []]
                    ]]
                ]],
                [v5, [
                    [v12, [
                        [v17, []]
                    ]]
                ]],
                [v6, [
                    [v8, [
                        [v13, [
                            [v18, []]
                        ]]
                    ]]
                ]],
            ]],
            [v3, [
                [v7, [
                    [v9, [
                        [v14, [
                            [v19, []]
                        ]]
                    ]],
                    [v10, [
                        [v15, [
                            [v20, []]
                        ]]
                    ]],
                ]],
            ]],
        ]]
    )

def crea2GRSP(v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20):
    return NodoA.fromList(
        [v1, [
            [v3, [
                [v7, [
                    [v10, [
                        [v15, [
                            [v20, []]
                        ]]
                    ]],
                    [v9, [
                        [v14, [
                            [v19, []]
                        ]]
                    ]],
                ]],
            ]],
            [v2, [
                [v6, [
                    [v8, [
                        [v13, [
                            [v18, []]
                        ]]
                    ]]
                ]],
                [v5, [
                    [v12, [
                        [v17, []]
                    ]]
                ]],
                [v4, [
                    [v11, [
                        [v16, []]
                    ]]
                ]],
            ]],
        ]]
    )

def crea3GR(v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20):
    return NodoA.fromList(
        [v1, [
            [v2, [
                [v4, [
                    [v11, [
                        [v16, []]
                    ]]
                ]],
                [v5, [
                    [v12, [
                        [v17, []],
                    ]]
                ]],
                [v6, [
                    [v8, [
                        [v13, [
                            [v18, []],
                        ]]
                    ]]
                ]],
            ]],
            [v3, [
                [v7, [
                    [v9, [
                        [v14, [
                            [v19, []],
                            [v20, []],
                        ]]
                    ]],
                    [v10, [
                        [v15, []],
                    ]],
                ]],
            ]],
        ]]
    )

def identificatoriGR(nodo):
    lista = [id(nodo)]
    for figlio in nodo.figli: lista += identificatoriGR(figlio)
    return lista

#####################################################################################

def test_program_1a():
    "\nsi applica il metodo incr() con intero 5 sull'albero in figura 1 del pdf\n"
    radice   = creaGR(1, 3, 2, 3, 3, 1,  6,  5, 4, 4)
    expected = creaGR(6, 8, 7, 8, 8, 6, 11, 10, 9, 9)
    explanation1 = "la radice dell'albero non e' di tipo NodoA"
    explanation2 = "l'albero ottenuto non ha la stessa radice di quello originale"
    explanation3 = "l'albero non ha il numero di nodi corretto"
    explanation4 = "l'albero e' diverso da quello atteso"
    ris = radice.incr(5)
    check(type(ris),     NodoA,      None, explanation1)
    check(id(ris),       id(radice), None, explanation2)
    check(contaGR(ris),  10,         None, explanation3)
    check(ris,           expected,   None, explanation4)
    return 1

def test_program_1b():
    "\nsi applica il metodo incr() con intero 3 sull'albero in figura 4 del pdf\n"
    radice   = crea2GR(6,  8,  7,  8,  8, 6, 11, 10,  9,  9, 5, 5, 5, 5, 5, 2, 2, 2, 2, 2)
    expected = crea2GR(9, 11, 10, 11, 11, 9, 14, 13, 12, 12, 8, 8, 8, 8, 8, 5, 5, 5, 5, 5)
    explanation1 = "la radice dell'albero non e' di tipo NodoA"
    explanation2 = "l'albero ottenuto non ha la stessa radice di quello originale"
    explanation3 = "l'albero non ha il numero di nodi corretto"
    explanation4 = "l'albero e' diverso da quello atteso"
    ris = radice.incr(3)
    check(type(ris),     NodoA,      None, explanation1)
    check(id(ris),       id(radice), None, explanation2)
    check(contaGR(ris),  20,         None, explanation3)
    check(ris,           expected,   None, explanation4)
    return 1

#####################################################################################

def test_program_2a():
    "\nsi applica il metodo coppia() sull'albero in figura 2 del pdf\n"
    explanation = "la coppia (numpari, numdispari) restituita non e' quella giusta"
    radice = creaGR(1, 3, 2, 3, 3, 1, 6, 5, 4, 4)
    ris = radice.coppia()
    check(ris, (4, 6), None, explanation)
    return 2

def test_program_2b():
    "\nsi applica il metodo coppia() sull'albero in figura 6 del pdf\n"
    explanation = "la coppia (numpari, numdispari) restituita non e' quella giusta"
    radice = crea3GR(6, 8, 7, 8, 8, 6, 11, 10, 9, 9, 5, 5, 5, 5, 200, 2, 2, 2, 2, 2)
    ris = radice.coppia()
    check(ris, (12, 8), None, explanation)
    return 2

def test_program_2c():
    "\nsi applica il metodo coppia() all'albero in figura 4 del pdf\n"
    explanation = "la coppia (numpari, numdispari) restituita non e' quella giusta"
    radice = crea2GR(6, 8, 7, 8, 8, 6, 11, 10, 9, 9, 5, 5, 5, 5, 5, 2, 2, 2, 2, 2)
    ris = radice.coppia()
    check(ris, (11, 9), None, explanation)
    return 2

#####################################################################################

def test_program_4a():
    "\nsi applica il metodo copiaSpecchio() all'albero in figura 4 del pdf ottenendo l'albero in figura 4b \n"
    explanation1 = "la radice dell'albero copiaSpecchio non e' di tipo NodoA"
    explanation2 = "l'albero copiaSpecchio non ha il numero di nodi corretto"
    explanation3 = "l'albero prodotto non e' la copiaSpecchio dell'originale"
    explanation4 = "la copiaSpecchio non ha tutti i nodi distinti dai nodi dell'originale"
    radice   = crea2GR(6, 8, 7, 8, 8, 6, 11, 10, 9, 9, 5, 5, 5, 5, 5, 2, 2, 2, 2, 2)
    radice1  = radice.copiaSpecchio()
    expected = crea2GRSP(6, 8, 7, 8, 8, 6, 11, 10, 9, 9, 5, 5, 5, 5, 5, 2, 2, 2, 2, 2)
    check(type(radice1),    NodoA,      None, explanation1)
    check(contaGR(radice1), 20,         None, explanation2)
    check(radice1,          expected,   None, explanation3)
    a = b = 0
    if len(set(identificatoriGR(radice1)) & set(identificatoriGR(radice))) != 0: a = 1;b = 0
    check(a, b, None, explanation4)
    return 2.5

def test_program_4b():
    "\nsi applica il metodo copiaSpecchio() all'albero in figura 4c del pdf ottenendo l'albero in figura 4d \n"
    explanation1 = "la radice dell'albero copiaSpecchio non e' di tipo NodoA"
    explanation2 = "l'albero copiaSpecchio non ha il numero di nodi corretto"
    explanation3 = "l'albero prodotto non e' la copiaSpecchio dell'originale"
    explanation4 = "la copiaSpecchio non ha tutti i nodi distinti dai nodi dell'originale"
    radice   = crea0GR(1, 7, 2, 6, 3, 5, 4)
    radice1  = radice.copiaSpecchio()
    expected = crea0GRSP(1, 7, 2, 6, 3, 5, 4)
    check(type(radice),     NodoA,      None, explanation1)
    check(contaGR(radice),  7,          None, explanation2)
    check(radice1,          expected,   None, explanation3)
    a = b = 0
    if len(set(identificatoriGR(radice1)) & set(identificatoriGR(radice))) != 0: a = 1;b = 0
    check(a, b, None, explanation4)
    return 2.5

#####################################################################################

def test_program_7a():
    "\nsi applica il metodo elimina() con valore 3 all'albero in figura 1 per ottenere  quello figura 8 pdf\n"
    explanation1 = "la radice dell'albero copia non e' di tipo NodoA"
    explanation2 = "l'albero ottenuto non ha la stessa radice di quello originale"
    explanation3 = "l'albero copia non ha il numero di nodi corretto"
    explanation4 = "l'albero ottenuto non e' quello atteso"
    radice   = creaGR(1, 3, 2, 3, 3, 1, 6, 5, 4, 4)
    expected = NodoA.fromList([1, [[1, [[5, []]]], [2, [[6, [[4, []], [4, []]]]]]]])
    ris = radice.elimina(3)
    check(type(ris),    NodoA,      None, explanation1)
    check(id(ris),      id(radice), None, explanation2)
    check(contaGR(ris), 7,          None, explanation3)
    check(ris,          expected,   None, explanation4)
    return 5

def test_program_7b():
    "\nsi applica il metodo elimina() con valore 2 all'albero in figura 9 per ottenere  quello figura 10 pdf\n"
    explanation1 = "la radice dell'albero copia non e' di tipo NodoA"
    explanation2 = "l'albero ottenuto non ha la stessa radice di quello originale"
    explanation3 = "l'albero copia non ha il numero di nodi corretto"
    explanation4 = "l'albero ottenuto non e' quello atteso"
    radice   = crea2GR(6, 8, 2, 2, 2, 2, 2, 2, 2, 2, 5, 5, 2, 5, 5, 2, 2, 2, 2, 2)
    expected = NodoA.fromList([6, [[8, [[5, []], [5, []]]], [5, []], [5, []]]])
    ris = radice.elimina(2)
    check(type(ris),    NodoA,      None, explanation1)
    check(id(ris),      id(radice), None, explanation2)
    check(contaGR(ris), 6,          None, explanation3)
    check(ris,          expected,   None, explanation4)
    return 5

#####################################################################################

tests = [
    test_program_1a, test_program_1b,
    test_program_2a, test_program_2b,
    test_program_4a, test_program_4b,
    test_program_7a, test_program_7b,
]

if __name__ == '__main__':
    runtests(tests,logfile='grade02.csv')
