'''
Si devono manipolare delle immagini in formato PNG disponibili su file.

Potete usare le librerie immagini e json per caricare e salvare i file PNG e JSON.

NOTA: non usate caratteri accentati (neanche nei commenti)
'''

import immagini
import json

########################################################################################

def compress_image(fileImageIn, fileCompressed):
    '''
    Esercizio 1: 6 punti
    Si progetti la funzione compress_image(fileImageIn, fileCompressed) che legge una immagine PNG e la trasforma in formato compresso usando il seguente schema:
    Per ogni linea dell'immagine ogni gruppo di N<256 pixel consecutivi dello stesso colore (R,G,B) viene rappresentato/sostituito dalla coppia di pixel (R, G, B), (0, 0, N).
    Esempio: la riga [ (255,0,0), (255, 0, 0), (255, 0, 0), (0, 0, 255) ] viene rappresentata dalla riga [ (255,0,0),(0,0,3), (0,0,255),(0,0,1) ].
    Il valore N non puo' quindi essere maggiore di 255, e se una sequenza di colori uguali consecutivi e' piu' lunga di 255,
    la si deve spezzare in tanti gruppi da 255 seguiti da un gruppo contenente il resto dei pixel.
    Per fare in modo che tutte le linee della immagine compressa abbiano la stessa lunghezza, a ciascuna linea viene aggiunto un 'padding' (riempimento)
    formato da tanti pixel (255, 255, 255) quanti bastano a rendere le linee uguali.
    La funzione, una volta letto e decodificato il file PNG fileImageIn, deve salvare nel file 'fileCompressed' l'immagine che si ottiene usando lo schema precedente.
    La funzione inoltre ritorna il numero totale di gruppi (coppie) individuato.

    :param fileImageIn: nome del file PNG da leggere
    :param fileCompressed: nome del file PNG compresso da creare
    :return: numero totale di coppie individuate
    '''
    # Mettete il vostro codice qui







###############################################################

def decompress_image(fileCompressed, fileImageOut):
    '''
    Esercizio 2: 4 punti
    si progetti la funzione decompress_image(fileCompressed, fileImageOut) che:
    - legge da fileCompressed una immagine PNG costruita secondo lo schema precedente e che ricostruisce l'immagine originale
        - eliminando da ciascuna linea il padding formato dai pixel (255, 255, 255) in fondo alle linee se presenti
        - espandendo le coppie (R, G, B), (0, 0, N) nei gruppi originali di N pixel (R,G,B) consecutivi uguali
    - salva l'immagine nel fileImageOut
    La funzione ritorna la larghezza dell'immagine ricreata.

    :param fileCompressed: nome del file PNG compresso come indicato nell'es. 1
    :param fileImageOut: nome del file PNG decompresso da ricreare
    :return: larghezza della immagine decompressa
    '''
    # Mettete il vostro codice qui







###############################################################

def color_histogram(fileImageIn, fileJsonOut):
    '''
    Esercizio 3: 3 punti
    si progetti la funzione color_frequence(fileImageIn, fileJsonOut) che calcola la frequenza dei colori presenti nella immagine fileImageIn e la salva in formato JSON.
    Le frequenze risultanti da salvare in formato JSON sono rappresentate sotto forma di un dizionario in cui:
    - le chiavi sono stringhe nel formato "R;G;B" dei soli colori presenti nella immagine (esempio: il colore rosso (255,0,0) -> "255;0;0")
    - i valori sono il numero di pixel con quel colore, presenti nella immagine
    La funzione inoltre ritorna il numero di colori diversi individuati.

    :param fileImageIn: nome del file PNG di cui calcolare le frequenze dei colori
    :param fileJsonOut: nome del file Json in cui salvare il dizionario dei colori contati
    :return: numero di colori diversi individuati
    '''
    # Mettete il vostro codice qui







###############################################################

def paint_histogram(fileJsonIn, fileImageOut):
    '''
    Esercizio 4: 4 punti
    si progetti la funzione paint_histogram(fileJsonIn, fileImageOut) che
    crea e salva in formato PNG l'istogramma delle frequenze dei colori letto dal file JSON fileJsonIn (nello stesso formato dell'esercizio 3).
    NOTA: ciascuna tupla (R,G,B) di interi che definisce un colore deve essere riottenuta dalle chiavi del dizionario letto dal file.
       Esempio:    "100;200;10" -> (100, 200, 10).
    L'immagine ha un numero di linee uguali al numero di colori presenti nel dizionario
    Le linee devono essere ordinate in ordine crescente di colore (in ordine di canale, cioe' prima in ordine di R, poi di G poi di B).
    Ciascuna linea e' formata da un numero di pixel dello stesso colore, pari al valore presente nel dizionario.
    Per rendere l'immagine rettangolare, a ciascuna linea se necessario devono essere aggiunti pixel neri (0, 0, 0)
    in modo tale che tutte le linee abbiano la stessa (minima) lunghezza.
    L'immagine risultante va salvata in formato PNG nel file fileImageOut.
    La funzione inoltre ritorna la larghezza dell'immagine creata.

    :param fileJsonIn:      nome del file Json che contiene il dizionario delle frequenze dei colori
    :param fileImageOut:    nome del file PNG da creare
    :return: larghezza della immagine creata
    '''
    # Mettete il vostro codice qui










###############################################################

