'''
Bisogna completare la definizione  della  classe NodoA
che eredita da Albero il costruttore, che prende come argomenti:
 - un intero (il valore del nodo) che viene memorizzato nell'attributo 'valore'
 - ed una lista di nodi (per default vuota) che viene memorizzata nell'attributo 'figli'

Implementare uno o più dei seguenti metodi della classe NodoA:

 - incr(self, x) con argomenti  un nodo e un intero x, incrementa di x il valore di tutti
 i nodi dell'albero radicato in quel nodo.

 - coppia(self) con argomento un nodo, che ritorna una coppia di interi (a,b) dove
  - a e' il numero di valori pari contenuti nei nodi dell'albero radicato in quel nodo
  - mentre b e' il numero di valori dispari.

 - copiaSpecchio(self) che, preso un nodo ritorna la radice di un nuovo albero che e'
 identico all'albero di partenza se non per il fatto che le liste dei nodi figli risultano
 invertite. Il primo albero non deve risultare modificato dall'operazione e
 le due copie non debbono avere nodi in comune.

 - elimina(self, x) che, preso un nodo e un intero x  ritorna il nodo radice
 dell'albero che si ottiene eliminando distruttivamente dall'albero radicato in quel nodo
 tutti i nodi con valore x.
 Eliminare un nodo dall'albero fa si' che tutti i suoi eventuali figli diventino figli del suo nodo padre,
 andando a sostituire il nodo eliminato dalla lista di 'figli' del suo padre.
 Se anche il nodo padre va eliminato allora i suoi figli (compresi questi) diventano figli del suo nodo nonno ecc.ecc.
 Si puo' assumere che il valore del nodo (self) sia diverso da x (e quindi la radice dell'albero non va eliminata).


Se necessario,  potete aggiungere altri metodi alla classe.

Per gli esempi vedere il file grade01.txt

AVVERTENZE:
- non usare caratteri non ASCII, come le lettere accentate (neanche nei commenti)
- non usare moduli che non sono nella libreria standard.
'''

from albero import Albero

class NodoA(Albero):
    # da Albero eredita il costruttore  __init__(self, valore, figli)

    def incr(self,x):
        '''inserire qui il vostro codice'''
        self.valore+=x
        for figlio in self.figli: figlio.incr(x)
        return self

    def coppia(self):
        '''inserire qui il vostro codice'''
        if self.valore%2==1: lista=[0,1]
        else: lista=[1,0]
        for figlio in self.figli:
            a,b=figlio.coppia()
            lista[0]+=a
            lista[1]+=b
        return tuple(lista)

    def nuove_foglie(self,x):
        '''inserire qui il vostro codice'''
        if self.figli:
            for figlio in self.figli:
                figlio.nuove_foglie(x)
        else:
            self.figli = [NodoA(x)]
        return self

    def copiaSpecchio(self):
        '''inserire qui il vostro codice'''
        lista=[]
        for figlio in self.figli:
            lista=[figlio.copiaSpecchio()]+lista
        nuovo=NodoA(self.valore)
        nuovo.figli=lista
        return nuovo

    def strutturaUguale(self,other):
        '''inserire qui il vostro codice'''
        if len(self.figli)!= len(other.figli):
            return False
        for f1,f2 in zip(self.figli,other.figli):
            if not f1.strutturaUguale(f2):
                return False
        return True

    def _modifica1(self,x):
        self.valore+=x
        for figlio in self.figli:
            figlio._modifica1(self.valore)

    def modifica(self):
        '''inserire qui il vostro codice'''
        self._modifica1(0)
        return self

    def elimina(self,x):
        '''inserire qui il vostro codice'''
        self._elimina(x)
        return self

    def _elimina(self,x):
        lista=[]
        for figlio in self.figli:
            lista += figlio._elimina(x)
        self.figli=lista
        if self.valore==x:
            return self.figli
        return [self]
